Whamcloud - gitweb
LU-4423 libcfs: disable preempt while sampling processor id.
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 BUILD_GEN=8
33
34 TOPDIR="$PWD"
35
36 KERNELDIR=
37 LINUX=
38 LUSTRE=
39 RELEASE=false
40 # XXX - some recent hacking has pretty much neutered this option.
41 #       search through this file for "-bb" and see how many places
42 #       simply don't account for this option
43 DO_SRC=true
44 DOWNLOAD=true
45 CANONICAL_TARGET=
46 TARGET=
47 TARGET_ARCH="$(uname -m)"
48 CONFIGURE_FLAGS=
49 EXTERNAL_PATCHES=
50 EXTRA_VERSION=
51 STAGEDIR=
52 TMPDIR=${TMPDIR:-"/var/tmp"}
53 TIMESTAMP=
54 # default OFED
55 OFED_TYPE="inkernel"
56 # this is the dir that should be used to store reuse products
57 REUSEBUILD=
58 # should cached products be used or force rebuilding?
59 USE_BUILD_CACHE=true
60 # what does this do exactly?  does it imply no kernel build?
61 IOKITRPM=true
62 OSDLDISKFSRPM=true
63 OSDZFSRPM=false
64 SMPTYPES="smp bigsmp default ''"
65 PATCHLESS=false
66 PATCHLESS_SERVER=false
67 WITH_ZFS=""
68 XEN=false
69 LINUXOBJ=
70 DISTRO=
71 KERNELTREE=
72 # default to not adding -lustre- into the kernel RPM package names
73 KERNEL_LUSTRE_NAMING=false
74 # default not use kabi check.
75 USE_KABI=false
76
77 # patchless build
78 KERNELRPMSBASE=
79 RPMSMPTYPE=
80
81 # from target file
82 SERIES=
83 BASE_ARCHS=
84 BIGMEM_ARCHS=
85 BOOT_ARCHS=
86 JENSEN_ARCHS=
87 SMP_ARCHS=
88 BIGSMP_ARCHS=
89 PSERIES64_ARCHS=
90 UP_ARCHS=
91
92 # not in the target file any more
93 CONFIG=
94
95 # build the lustre-tests rpm?
96 LUSTRE_TESTS=true
97
98 DATE=$(date)
99
100 RPMBUILD=
101
102 export CC=${CC:-gcc}
103
104 # Readlink is not present on some older distributions: emulate it.
105 readlink() {
106     local path=$1 ll
107
108     if [ -L "$path" ]; then
109         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
110         echo "${ll/* -> }"
111     else
112         return 1
113     fi
114 }
115
116 usage() {
117     cat <<EOF
118 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
119
120   --external-patches=EXTERNAL_PATCHES
121     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
122     look for seres and config files in before looking in the lustre
123     tree.
124
125   --extraversion=EXTRAVERSION
126     Text to use for the rpm release and kernel extraversion.
127
128   --timestamp=TIMESTAMP
129     Date of building lustre in format YYYYMMDDhhmmss
130
131   --reusebuild=DIR
132     Try to reuse old kernel builds from DIR
133
134   --kernelrpm=DIR
135     Path to distro kernel RPM collection
136
137   --ccache
138     Use ccache
139
140   --norpm
141     Unused.
142
143   --patchless
144     Build lustre client only
145
146   --patchless-server
147     Build lustre server without patching the kernel
148
149   --distro=DISTRO
150     Which distro using. Autodetect by default
151
152   --kerneldir=KERNELDIR
153     Directory containing Linux source tarballs referenced by target
154     files.
155
156   --kerneltree=KERNELTREE
157     Directory containing dirs with Linux source tarballs referenced by target
158     files. Dir names in format kernel version ('2.6.9', etc.)
159
160   --linux=LINUX --with-linux=LINUX
161     Directory of Linux kernel sources.  When this option is used, only
162     Lustre modules and userspace are built.
163
164   --lustre=LUSTRE
165     Path to an existing lustre source tarball to use.
166
167   --nodownload
168     Do not try to download a kernel from downloads.hpdd.intel.com
169
170   --nosrc
171     Do not build a .src.rpm, a full kernel patch, or a patched kernel
172     tarball.
173
174   --ofed-type
175     Type of OFED to build with lustre: inkernel, ofa, mlnx, ifs
176     ofa: OpenFabrics Alliance
177     mlnx: Mellanox
178     ifs: Intel True Scale Fabric
179
180   --ofed-version
181     Version of external OFED to build with lustre
182
183   --mlnx-version
184     Version of external Mellanox OFED to build with lustre
185
186   --ofed-src
187     Tarball for either OFED. Tarball must follow below format
188     OFED-<ofed-version>.tgz regardless of vendors
189     It's likely that you need to reconstruct the directory name
190     It must be placed under KERNELTREE directory
191
192   --ldiskfs
193     Build with ldiskfs support. (Deprecated, always true)
194
195   --noiokit
196     Do not build lustre-iokit RPM. Now true by default
197
198   --publish
199     Unused.
200
201   --release
202     Specifies that the files generated do not include timestamps, and
203     that this is an official release.
204
205   --disable-zfs
206     Build Lustre without ZFS.
207
208   --src
209     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
210
211   --stage=DIR
212     Directory used to stage packages for release.  RPMs will be placed
213     more or less in DIR/<target>-<arch>, and the tarball will be
214     placed in DIR.
215
216   --target=TARGET
217     The name of the target to build.  The available targets are listed
218     below.
219
220   --xen
221     Builds a Xen domX kernel.
222
223   --set-value
224     Sets a variable to a given value.
225
226 EOF
227
228 #   list_targets
229
230     fatal "$1" "$2"
231 }
232
233 # canonicalize a relative path to a file
234 canon_filepath() {
235     local PATH="$1"
236
237     if [ ! -f "$PATH" ]; then
238         return 1
239     fi
240
241     local FILE=${PATH##*/}
242     local DIR=${PATH%/*}
243
244     echo $(canon_path "$DIR")/$FILE
245     return 0
246 }
247
248 # canonicalize a relative path to a dir
249 canon_path() {
250     local PATH="$1"
251
252     if [ ! -d "$PATH" ]; then
253         return 1
254     fi
255
256     pushd "$PATH" >/dev/null || return 1
257     local CANONPATH=$PWD
258     popd >/dev/null
259
260     echo "$CANONPATH"
261     return 0
262 }
263
264 check_options() {
265
266     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
267         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
268     fi
269
270         if $PATCHLESS && $PATCHLESS_SERVER; then
271                 usage 1 "Can not use both --patchless and --patchless-server."
272         fi
273
274         if [ -n "${OFED_SRC}" ]; then
275                 if [ -z "${OFED_VERSION}" ]; then
276                         usage 1 "Need to provide version for file ${OFED_SRC}."
277                 fi
278                 if [ "${OFED_TYPE}" = "inkernel" ]; then
279                         usage 1 "Need to provide ofed type for file ${OFED_SRC}."
280                 fi
281         else
282                 if [ "${OFED_TYPE}" != "inkernel" -a -z "${OFED_VERSION}" ]; then
283                         usage 1 "Need to provide version for $OFED_TYPE OFED"
284                 fi
285
286                 if [ "${OFED_TYPE}" = "inkernel" -a -n "${OFED_VERSION}" ]; then
287                         usage 1 "Can not specify version with inkernel OFED"
288                 fi
289         fi
290
291     if [ -z "$DISTRO" ] ; then
292         DISTRO=$(autodetect_distro)
293         # remove separator
294         DISTRO=${DISTRO/-/}
295     fi
296     DISTROMAJ=${DISTRO%%.*}
297
298     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
299
300     if [ -z "$LINUX" ]; then
301         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
302             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
303
304         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
305             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
306
307 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
308 #       [ -r "$TARGET_FILE" ] || \
309 #               usage 1 "Target '$TARGET' was not found."
310     fi
311
312     case $TARGET in
313         3.12-sles12 | 4.4-sles12)
314             CANONICAL_TARGET="sles12"
315             ;;
316         3.10-rhel7*)
317             CANONICAL_TARGET="rhel7"
318             ;;
319         2.6-rhel6*)
320             CANONICAL_TARGET="rhel6"
321             ;;
322         2.6-rhel5)
323             CANONICAL_TARGET="rhel5"
324             ;;
325         2.6-rhel4)
326             CANONICAL_TARGET="rhel-2.6"
327             ;;
328         2.6-suse)
329             CANONICAL_TARGET="sles-2.6"
330             ;;
331         2.6-sles10)
332             CANONICAL_TARGET="sles10-2.6"
333             ;;
334         2.6-sles11 | 3.0-sles11)
335             CANONICAL_TARGET="sles11"
336             ;;
337         2.6-oel5)
338             CANONICAL_TARGET="oel5"
339             ;;
340         hp_pnnl-2.4)
341             CANONICAL_TARGET="hp-pnnl-2.4"
342             ;;
343         2.6-vanilla \
344             | suse-2.4.21-2 \
345             | rh-2.4 \
346             | rhel-2.4 \
347             | sles-2.4 \
348             | 2.6-patchless)
349                 CANONICAL_TARGET="$TARGET"
350                 ;;
351     esac
352
353     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
354     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
355     local timestamplength="${#TIMESTAMP}"
356     if [ $timestamplength -eq 12 ]; then
357         TIMESTAMP="${TIMESTAMP}00"
358     elif [ $timestamplength -ne 14 ]; then
359         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
360     fi
361
362     RPMBUILD=$(which rpmbuild 2>/dev/null | head -n 1)
363     RPMBUILD=${RPMBUILD:-$(which rpm 2>/dev/null | head -n 1)}
364     if [ -z "$RPMBUILD" ]; then
365         usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
366     fi
367
368     local BINDIR="$TOPDIR/bin"
369     if [ -d $BINDIR ]; then
370         rm -rf $BINDIR >/dev/null 2>&1 || true
371     fi
372
373     mkdir -p $BINDIR || fatal 1 "error trying to create $BINDIR"
374     export PATH=$BINDIR:$PATH
375
376     cat >${BINDIR}/rpmbuild <<EOF
377 #!/bin/bash
378
379 ARGS="\${FIND_REQUIRES:+--define \"__find_requires \$FIND_REQUIRES\"}"
380 for arg; do
381     case \$arg in
382     *\'* ) ARGS="\$ARGS \"\$arg\"" ;;
383     * ) ARGS="\$ARGS '\$arg'" ;;
384     esac
385 done
386
387 eval $RPMBUILD \$ARGS
388 EOF
389     chmod 755 ${BINDIR}/rpmbuild
390
391     if [ -n "$CCACHE" ]; then
392         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
393
394         if which "$CCACHE" &>/dev/null; then
395             local ccache=$(which "$CCACHE" 2>/dev/null | head -n 1)
396
397             ln -s "$ccache" ${BINDIR}/ccache
398             ln -s "$ccache" ${BINDIR}/cc
399             ln -s "$ccache" ${BINDIR}/$CC
400
401             export CCACHE
402             export CC="ccache $CC"
403             # zero the cache so we can see how effective we are being with it
404             echo -n "ccache "
405             ccache -z
406
407             # get some ccache stats when we are done
408             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
409             # should remove the ccache trap if lbuild is interrupted
410             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
411         fi
412     fi
413
414     return 0
415 }
416
417 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
418 compare_version () {
419     [[ $1 == $2 ]] && return 1
420     local IFS=.
421     local i val1=($1) val2=($2)
422
423     # padding zero to val1 if it needs
424     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
425         val1[i]=0
426     done
427     for ((i=0; i<${#val1[@]}; i++)); do
428         [[ -z ${val2[i]} ]] && return 1
429
430         if [[ ${val1[i]} < ${val2[i]} ]]; then
431             return 0
432         elif [[ ${val1[i]} > ${val2[i]} ]]; then
433             return 1
434         fi
435     done
436     return 1
437 }
438
439 uniqify() {
440
441     echo $(echo "$*" | xargs -n 1 | sort -u)
442
443 }
444
445 fetch_url() {
446     local url="$1"
447     local target="$2"
448
449     if [ -z "$target" ]; then
450         fatal 1 "fetch_url() called without a target to fetch to"
451     fi
452
453     if [ -d $target ]; then
454         target+="/${url##*/}"
455     fi
456
457     local rc=0
458     if which wget >/dev/null 2>&1; then
459         if ! wget -nv "$url" -O "$target"; then
460             rc=${PIPESTATUS[0]}
461         fi
462     elif which curl >/dev/null 2>&1; then
463         if ! curl -n -L -s -o "$target" "$url"; then
464             rc=${PIPESTATUS[0]}
465         fi
466     else
467         fatal 1 "Could not find either wget or curl to fetch URLs."
468     fi
469
470     return $rc
471
472 }
473
474 download_srpm() {
475         local target=$1
476         local srpm=$2
477         local force="${3:-false}"
478
479         # let the download_file handle the concurrency
480         if $DOWNLOAD; then
481                 local location= \
482                 "https://downloads.hpdd.intel.com/public/kernels/$target/old"
483                 # get the location from a distro specific method if it exists
484                 if type -p kernel_srpm_location; then
485                         location=$(kernel_srpm_location)
486                 fi
487                 echo "Downloading $location/$srpm..."
488                 if ! download_file \
489                         "$location/$srpm" "$KERNELDIR/$srpm" "$force" 2>&1 ||
490                         [ ! -s "$KERNELDIR/$srpm" ]; then
491                         rm -f $KERNELDIR/$srpm
492                         fatal 1 "Could not download target $target's kernel \
493 SRPM $srpm from $location."
494                 fi
495         fi
496 }
497
498 download_debuginfo_common() {
499         local rpm=$1
500         local force="${2:-false}"
501
502         # let the download_file handle the concurrency
503         if $DOWNLOAD; then
504                 # get the location from a distro specific method if it exists
505                 if type -p kernel_debuginfo_location; then
506                 location=$(kernel_debuginfo_location)
507                 fi
508                 echo "Downloading $location/$rpm"
509                 if ! download_file \
510                         "$location/$rpm" "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm" "$force" 2>&1 ||
511                         [ ! -s "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm" ]; then
512                         rm -f $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$rpm
513                         fatal 1 "Could not download $rpm from $location."
514                 fi
515         fi
516 }
517
518 download_file() {
519     local from="$1"
520     local to="$2"
521     local force="$3"
522
523     local file=${from##*/}
524
525     if [ -d $to ]; then
526         to="$to/$file"
527     fi
528
529     local semaphore="$to-downloading"
530
531     is_downloading() {
532         if [ ! -f $semaphore ]; then
533             return 1
534         fi
535
536         # make sure the download has not been aborted
537         local now=$(date +%s)
538         local file_mtime=$(stat -c %Y "$to")
539         local staleness=$((now - file_mtime))
540         # let's assume an active download will write at least once a minute
541         if [ $staleness -gt 60 ]; then
542             return 1
543         fi
544
545         return 0
546     }
547
548     is_downloaded() {
549         # if the semaphore file exists, the file is either still downloading
550         # or a download was aborted and we cannot trust the target file
551         if [ -f $semaphore ]; then
552             return 1
553         fi
554
555         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
556             return 0
557         fi
558
559         return 1
560     }
561
562     if $force || ! is_downloaded; then
563         if is_downloading; then
564             echo "Somebody else is downloading $from..."
565             while is_downloading; do
566                 echo "Waiting for $to to finish downloading"
567                 sleep 60
568             done
569             if is_downloaded; then
570                 return 0
571             else
572                 echo "The download we were waiting for seems to have been aborted"
573             fi
574
575         fi
576
577         if $DOWNLOAD; then
578             echo "Downloading $from..."
579             # flag others so they don't try to download also
580             push_exit_trap "rm -f $to $semaphore" "download"
581             touch $semaphore
582             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
583                 # the trap will remove the files via the fatal below
584                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
585             fi
586             rm -f $semaphore
587             delete_exit_trap "download"
588         else
589             fatal 1 "${to##*/} not found in directory ${to%/*}."
590         fi
591     fi
592
593     return 0
594
595 }
596
597 download_ofed() {
598         local ofed_type="$1"
599         local ofed_version="$2"
600         local force="${3:-false}"
601         local distro_name="${DISTRO}"
602         local arch="${TARGET_ARCH}"
603         local location
604         local file
605
606         #if a src tarball has been given in the command line, we use it
607         #The format of the tarball must be OFED-${OFED_VERSION}.tgz
608         [ -n "${OFED_SRC}" ] && return 0
609
610         case $ofed_type in
611                 ofa)
612                         location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version}/"
613                         # version include RC
614                         if [[ $ofed_version = *-[rR][cC][0-9] ]]; then
615                                 ofed_version_loc=${ofed_version%%-[rR][cC][0-9]}
616                                 location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version_loc}/"
617                         fi
618                         # daily build
619                         if [[ $ofed_version = *-daily ]]; then
620                                 ofed_version=${ofed_version/-daily/}
621                                 location="https://www.openfabrics.org/downloads/OFED/ofed-${ofed_version}-daily/"
622                                 # find the filename for latest version
623                                 ofed_version=$(curl -1 -s "$location" | sed -nre "s/.*href=\"OFED-(${ofed_version//./\\.}-[0-9]{8}-[0-9]{4}).tgz.*$/\1/p" | tail -1)
624                                 if [ -z "$ofed_version" ]; then
625                                         fatal 1 "Could not determine the filename of the OFED snapshot from daily "
626                                 fi
627                         fi
628
629                         file="OFED-${ofed_version}.tgz"
630                         download_file "$location/$file" "$KERNELTREE" "$force"
631                         ;;
632                 mlnx)
633                         location="http://www.mellanox.com/downloads/ofed/MLNX_OFED-${ofed_version}"
634                         # this is a work around for suse distro (sles11.3). what we need is
635                         # sles11sp3. We really need to redesign how we use target and distro
636                         [[ $distro_name =~ sles ]] && distro_name=${DISTRO/./sp}
637                         file="MLNX_OFED_LINUX-${ofed_version}-${distro_name}-${arch}.tgz"
638                         download_file "$location/$file" "$KERNELTREE" "$force"
639                         ;;
640                 ifs)
641                         location="http://downloadmirror.intel.com/24625/eng/"
642                         file="IntelIB-Basic.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.${ofed_version}.tgz"
643                         download_file "$location/$file" "$KERNELTREE" "$force"
644                         ;;
645                 *)
646                         fatal 1 "Error: unknown OFED type: $ofed_type"
647
648         esac
649         # version might change due to detect daily version
650         OFED_VERSION=${ofed_version}
651
652 }
653
654 load_target() {
655
656     EXTRA_VERSION_save="$EXTRA_VERSION"
657     for patchesdir in "$EXTERNAL_PATCHES" \
658                       "$TOPDIR/lustre/lustre/kernel_patches"; do
659         TARGET_FILE="$patchesdir/targets/$TARGET.target"
660         [ -r "$TARGET_FILE" ] && break
661     done
662     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
663
664     echo "Loading target config file $TARGET.target..."
665
666     # if the caller specified an OFED_VERSION it should override whatever
667     # the target file specifies
668     local env_OFED_VERSION="$OFED_VERSION"
669
670     . "$TARGET_FILE"
671
672     if [ -n "$env_OFED_VERSION" ]; then
673         OFED_VERSION="$env_OFED_VERSION"
674     fi
675
676     # doesn't make any sense to build OFED for xen domX's
677     if $XEN; then
678         OFED_VERSION=""
679     fi
680
681     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
682     #       go away and the target just specify the $RPMSMPTYPE
683     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
684
685     # CC might have been overwritten in TARGET_FILE
686     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
687         export CCACHE && export CC="ccache $CC"
688     fi
689
690     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
691         KERNELDIR="$KERNELTREE/${lnxmaj}"
692         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
693     fi
694
695     # verify the series is available
696     if [ "$SERIES" ]; then
697         for series in $SERIES; do
698             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
699                 [ -r "$patchesdir/series/$series" ] && continue 2
700             done
701             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
702         done
703     fi
704
705     # set the location of the .config file
706     local XENPOSTFIX=""
707     if $XEN; then
708         XENPOSTFIX="-xen"
709     fi
710
711     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
712         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
713     fi
714
715     local lnxrelnew=${lnxrel//-/_}
716
717     # remember the EXTRA_VERSION before we diddle it here
718     # XXX - we really should not diddle with any values read in from the
719     #       target file.  if we want to modify a value, we should create
720     #       a new variable.
721     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
722
723     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
724         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
725     fi
726
727     if [ "$EXTRA_VERSION_save" ]; then
728         EXTRA_VERSION="$EXTRA_VERSION_save"
729     elif ! $RELEASE; then
730         # if there is no patch series, then this is not a lustre specific
731         # kernel.  don't make it look like one
732         if $PATCHLESS || [ -n "$SERIES" ]; then
733             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
734         fi
735     fi
736     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
737 }
738
739 tarflags() {
740     local file="$1"
741
742     echo -n '--wildcards '
743     case "$file" in
744         '')
745             fatal 1 "tarflags(): File name argument missing."
746             ;;
747         *.tar.gz | *.tgz)
748             echo '-zxf'
749             ;;
750         *.tar.bz2)
751             echo '-jxf'
752             ;;
753         *.tar)
754             echo '-xf'
755             ;;
756         *)
757             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
758             ;;
759     esac
760
761 }
762
763 untar() {
764     local tarfile="$1"
765     shift
766     local extractfile="$@"
767
768     echo "Untarring ${tarfile##*/}..."
769     tar $(tarflags "$tarfile") "$tarfile" $extractfile
770
771 }
772
773 unpack_ofed() {
774         local ofed_type="$1"
775         local ofed_version="$2"
776         local distro_name="${DISTRO}"
777         local arch="${TARGET_ARCH}"
778         local file
779
780         #if a src tarball has been given in the command line, we use it
781         #The format of the directory after untar MUST be in OFED-${version}
782         #even if it's from MLNX or IFS...or whatever
783         if [ -n "${OFED_SRC}" ]; then
784                 if ! untar "$KERNELTREE/${OFED_SRC}"; then
785                         return 1
786                 else
787                         [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
788                 fi
789         fi
790         case $ofed_type in
791                 ofa)
792                         file="OFED-${ofed_version}"
793                         if ! untar "$KERNELTREE/${file}.tgz"; then
794                                 return 1
795                         fi
796                         [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
797                         ;;
798                 mlnx)
799                         # this is a work around for suse distro (sles11.3). what we need is
800                         # sles11sp3. We really need to redesign how we use target and distro
801                         [[ $distro_name =~ sles ]] && distro_name=${DISTRO/./sp}
802                         file="MLNX_OFED_LINUX-${ofed_version}-${distro_name}-${arch}"
803
804                         # it's not important what distro we get the tarball since we only
805                         # interest in the src
806                         if ! untar "$KERNELTREE/${file}.tgz"; then
807                                 return 1
808                         fi
809                         # we need to untar again to get the src since it's being
810                         # wrapped inside the tarball
811                         # There are cases where the source version is different
812                         # than the tarball.
813                         # (ie. MLNX_OFED_LINUX-2.3-1.0.1 but MLNX_OFED_SRC-2.3-1.0.0)
814                         local src=$(ls ${file}/src/MLNX_OFED_SRC-${ofed_version%.*}*.tgz)
815                         if ! untar "$src"; then
816                                 return 1
817                         fi
818                         [ -d OFED ] || ln -sf MLNX_OFED_SRC-[0-9].[0-9]* OFED
819                         [ -d OFED_RPMS ] || ln -sf ${file}/RPMS OFED_RPMS
820                         ;;
821                 ifs)
822                         file="IntelIB-Basic.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.${ofed_version}"
823                         if ! untar "$KERNELTREE/${file}.tgz"; then
824                                 return 1
825                         fi
826                         [ -d OFED ] || ln -sf $file/IntelIB-OFED.$(echo ${distro_name%%.*} | tr '[:lower:]' '[:upper:]')-${arch}.* OFED
827                         ofed_version="$(cat OFED/Version)"
828                         ;;
829         esac
830         # version might change due to detect daily version
831         OFED_VERSION=${ofed_version}
832 }
833
834 unpack_lustre() {
835
836     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
837     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
838
839 }
840
841 do_patch_linux() {
842
843     local do_patch=${1:-true}
844
845     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
846     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
847     $do_patch && pushd linux >/dev/null
848     for series in $SERIES; do
849         echo -n "Applying series $series:"
850         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
851             [ -r "$patchesdir/series/$series" ] || continue
852             SERIES_FILE="$patchesdir/series/$series"
853             for patch in $(<"$SERIES_FILE"); do
854                 echo -n " $patch"
855                 PATCH_FILE="$patchesdir/patches/$patch"
856                 [ -r "$PATCH_FILE" ] || \
857                     fatal 1 "Patch $patch does not exist in Lustre tree."
858                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
859                     rm -f $FULL_PATCH
860                     fatal 1 "Error adding patch $patch to full patch."
861                 }
862                 if $do_patch; then
863                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
864                         rm -f $FULL_PATCH
865                         fatal 1 "Error applying patch $patch."
866                     }
867                 fi
868             done
869             break
870         done
871         echo
872     done
873     $do_patch && popd >/dev/null
874     echo "Full patch has been saved in ${FULL_PATCH##*/}."
875
876 }
877
878 build_lustre() {
879     local linux="$1"
880     local linuxobj="$2"
881     local configure_args=""
882
883     cp "$LUSTRE" SOURCES
884
885     pushd lustre >/dev/null
886
887     if ! build_lustre_dkms; then
888         popd >/dev/null # pushd lustre
889         return 255
890     fi
891
892     echo "Building Lustre RPMs for: $TARGET_ARCH"
893
894     # If server we now build the spl and zfs modules against the lustre kernel.
895     # These are required prior to the building of lustre server. Client does
896     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
897     # line above so is at least consistant.
898     if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
899         if ! build_spl_zfs; then
900             popd >/dev/null # pushd lustre
901             return 255
902         fi
903     fi
904
905     if $PATCHLESS; then
906         configure_args="$configure_args --disable-server"
907     fi
908
909     # ditto for the lustre-tests boolean
910     if ! $LUSTRE_TESTS; then
911         configure_args="$configure_args --disable-tests"
912     fi
913
914     if ! $IOKITRPM; then
915         configure_args="$configure_args --disable-iokit"
916     fi
917
918     if ! $OSDZFSRPM; then
919         configure_args="$configure_args --without-zfs"
920     fi
921
922     if ! $OSDLDISKFSRPM; then
923         configure_args="$configure_args --disable-ldiskfs"
924     fi
925
926     configure_args="$configure_args --with-linux=$linux"
927     configure_args="$configure_args ${linuxobj:+--with-linux-obj=$linuxobj}"
928
929     # allow environment setting to override ldiskfs series selection
930     [ -n "$LDISKFS_SERIES" ] && export LDISKFS_SERIES
931
932     ./configure $configure_args $CONFIGURE_FLAGS 2>&1 ||
933         fatal 1 "Error in configure."
934
935     if type -p apply_kmod_requires_conflicts; then
936         apply_kmod_requires_conflicts
937     fi
938
939     make rpms 2>&1 ||
940         fatal 1 "Error building rpms for $TARGET_ARCH."
941
942     # move RPMs into place where they are expected to be
943     mv -f *lustre*.${TARGET_ARCH}.rpm $TOPDIR/RPMS/${TARGET_ARCH}/
944     mv -f lustre-*.src.rpm $TOPDIR/SRPMS/
945
946     popd >/dev/null
947         if type -p cleanup_rpmmacros; then
948                 cleanup_rpmmacros
949         fi
950
951     return 0
952 }
953
954 build_lustre_dkms() {
955     local build_args=""
956     local ver=$(sed -n -e 's/^LUSTRE_VERSION = //p' LUSTRE-VERSION-FILE)
957
958     echo "Building Lustre DKMS RPMs for: $TARGET_ARCH"
959     ./configure --enable-dist || fatal 1 "Error in DKMS configure."
960
961     if $PATCHLESS; then
962         build_args="--without servers"
963     fi
964
965     rpmbuild --define "_topdir $TOPDIR" $build_args -bs lustre-dkms.spec ||
966         fatal 1 "Error building DKMS .src.rpm for $TARGET_ARCH."
967
968     if $PATCHLESS; then
969         rpmbuild --define "_topdir $TOPDIR" $build_args \
970              --rebuild $TOPDIR/SRPMS/lustre-client-dkms-$ver-*.src.rpm ||
971         fatal 1 "Error building DKMS .rpm for $TARGET_ARCH."
972     else
973         rpmbuild --define="_topdir $TOPDIR" --with servers \
974             --with zfs --without ldiskfs -bs lustre-dkms.spec ||
975         fatal 1 "Error creating DKMS (zfs) .srpm for $TARGET_ARCH."
976         rpmbuild --define="_topdir $TOPDIR" --with servers \
977             --without zfs --with ldiskfs -bs lustre-dkms.spec ||
978         fatal 1 "Error creating DKMS (ldiskfs) .srpm for $TARGET_ARCH."
979         rpmbuild --define="_topdir $TOPDIR" --with servers \
980             --with zfs --with ldiskfs -bs lustre-dkms.spec ||
981         fatal 1 "Error creating DKMS (all) .srpm for $TARGET_ARCH."
982
983         rpmbuild --rebuild --define="_topdir $TOPDIR" --with servers \
984             --with zfs --without ldiskfs $TOPDIR/SRPMS/lustre-zfs-dkms-$ver-*.src.rpm ||
985         fatal 1 "Error building DKMS (zfs) .rpm for $TARGET_ARCH."
986         rpmbuild --rebuild --define="_topdir $TOPDIR" --with servers \
987             --without zfs --with ldiskfs $TOPDIR/SRPMS/lustre-ldiskfs-dkms-$ver-*.src.rpm ||
988         fatal 1 "Error building DKMS (ldiskfs) .rpm for $TARGET_ARCH."
989         rpmbuild --rebuild --define="_topdir $TOPDIR" --with servers \
990             --with zfs --with ldiskfs $TOPDIR/SRPMS/lustre-all-dkms-$ver-*.src.rpm ||
991         fatal 1 "Error building DKMS (all) .rpm for $TARGET_ARCH."
992     fi
993
994     return 0
995 }
996
997 ###
998 # build_spl_zfs
999 #
1000 # Fetch spl/zfs from the git repo and prepare for lustre build
1001 #
1002 # Overrides:
1003 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
1004 #   SPLZFSTAG     - Tag to checkout of clone repositories
1005 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
1006 #
1007 # return 0 if successful, else 255
1008 build_spl_zfs() {
1009     # make sure the RPM build environment is set up
1010     pushd $TOPDIR
1011     create_rpmbuild_dirs
1012     popd
1013
1014     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
1015     # destination for the rpms
1016     export RPM_BUILD_ROOT=$TOPDIR
1017     SPLZFSVER=${SPLZFSVER:-0.7.8}
1018     SPLZFSTAG=${SPLZFSTAG:-}
1019
1020     # The files expect a kver to be set to the kernel version .
1021     local kver=$(find_linux_release)
1022
1023     # build and install the spl and zfs (and -devel) RPMs for lustre to use
1024     local pkg
1025     for pkg in spl zfs; do
1026
1027         local rpmpkg
1028
1029         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*|tail -1)"
1030
1031         # need to fetch the repo in order to build it.
1032         # default to github but allow override
1033         git clone -n ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1034
1035         pushd $pkg || return 255
1036         local tag
1037         if [ -n "$SPLZFSTAG" ]; then
1038             tag=$SPLZFSTAG
1039         else
1040             tag=$pkg-$SPLZFSVER
1041         fi
1042         git checkout -b lbuild $tag || fatal 1 "Failed to checkout \"$tag\" for $pkg.git"
1043
1044         # This differentiates between older zfs versions
1045         if [ -f $pkg-modules.spec.in ]; then
1046             rpmpkg=$pkg-modules
1047             specdir=.
1048             speclist="$pkg.spec $rpmpkg.spec"
1049         else
1050             rpmpkg=kmod-$pkg-devel
1051             specdir=rpm/generic
1052             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1053         fi
1054
1055         sh autogen.sh || return 255
1056
1057         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1058                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1059             ! make dist 2>&1; then
1060             popd
1061             return 255
1062         fi
1063         popd
1064
1065         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1066            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1067         if [ -f $pkg/scripts/kmodtool ]; then
1068             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1069         fi
1070
1071         local rpmb
1072         if $DO_SRC; then
1073             rpmb=-ba
1074         else
1075             rpmb=-bb
1076         fi
1077
1078         # set search dir for our own kmodtool to find correct
1079         # directories
1080         export KERNELSOURCE=$(dirname ${LINUX})
1081         # Manually build rpms
1082         for spec in $speclist; do
1083             echo "Building RPMs from $pkg/$specdir/$spec"
1084             if ! rpmbuild $rpmb $pkg/$specdir/$spec \
1085                 --nodeps -v \
1086                 --define "_use_internal_dependency_generator 0" \
1087                 --define "require_kdir ${LINUX}" \
1088                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1089                 ${spldir:+--define "require_spldir ${spldir}"} \
1090                 --define "kver $kver" \
1091                 --define "kernels $kver" \
1092                 --define "_tmppath /var/tmp" \
1093                 --define "kernelbuildroot $TOPDIR/reused" \
1094                 --define "_topdir $TOPDIR" 2>&1; then
1095                 return 255
1096             fi
1097         done
1098
1099         # We have built the rpms for the package. Now we need to extract the
1100         # contained files so we can build further things against them
1101         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1102
1103         # cpio only extract to pwd so we need to go there.
1104         pushd $TOPDIR
1105         local rpm
1106         for rpm in $rpms; do
1107             rpm2cpio $rpm | cpio -id
1108         done
1109
1110         if [ "$pkg" == "zfs" ]; then
1111             # We also need to extract both the zfs and zfs-devel rpms
1112             # the zfs rpm is needed because it has the actual libraries in
1113             # it and the zfs-devel rpm only has unversioned symlinks to the
1114             # libraries in the zfs rpm
1115             # this will all change one day when we have a libzfs rpm per
1116             # https://github.com/zfsonlinux/zfs/issues/2329
1117             # and it looks like it could be one day soon:
1118             # https://github.com/zfsonlinux/zfs/pull/2341
1119             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
1120             for rpm in $devel_rpms; do
1121                 rpm2cpio $rpm | cpio -id
1122             done
1123             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1124         fi
1125         popd
1126
1127         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*|tail -1) ${CONFIGURE_FLAGS}"
1128         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1129     done
1130
1131     OSDZFSRPM=true
1132
1133     return 0
1134 }
1135
1136 stage() {
1137
1138     [ "$STAGEDIR" ] || return 0
1139
1140     rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${TARGET_ARCH}"
1141     echo "${0##*/}: Copying RPMs into ${rpmdir}"
1142     mkdir -p "${rpmdir}"
1143     for rpm in $(ls RPMS/${TARGET_ARCH}/*.rpm RPMS/noarch/*.rpm); do
1144         cp -v $rpm "${rpmdir}"
1145     done
1146
1147     cp -v "$LUSTRE" "$STAGEDIR"
1148
1149 }
1150
1151 set_rpm_smp_type() {
1152
1153     local infact_arch="${TARGET_ARCH}"
1154
1155     RPMSMPTYPE=""
1156     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1157
1158     local smp_type
1159     for smp_type in $SMP_ARCHS; do
1160         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1161     done
1162
1163     for smp_type in $BIGSMP_ARCHS; do
1164         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1165     done
1166
1167     for smp_type in $PPC64_ARCHS; do
1168         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1169     done
1170
1171     for smp_type in $DEFAULT_ARCHS; do
1172         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1173     done
1174
1175 }
1176
1177 # This function takes a linux include tree and digs out the linux release
1178 # from it. It is never called directly, only called from the distro
1179 # specific function find_linux_release() in lbuild-{rhel,sles}.
1180 _find_linux_release() {
1181     local SRC="$1"
1182     local LINUXRELEASEHEADER=""
1183
1184     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1185     if [ -s $SRC/include/generated/utsrelease.h ]; then
1186         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1187     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1188         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1189     fi
1190
1191     if [ ! -s $LINUXRELEASEHEADER ]; then
1192         fatal 1 "could not find UTS_RELEASE"
1193     fi
1194
1195     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1196 }
1197
1198 # unpack kernel(/source/devel) RPM
1199 #
1200 unpack_linux_devel_rpm() {
1201     local kernelrpm="${1}"
1202
1203     [ -f "$kernelrpm" ] || return 255
1204     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1205
1206     pushd $TOPDIR/reused &>/dev/null || return 255
1207
1208     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1209         return 255
1210     fi
1211
1212     # call a distro specific hook, if available
1213     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1214         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1215             return 255
1216         fi
1217     fi
1218
1219     popd &>/dev/null
1220
1221     find_linux_devel_paths $TOPDIR/reused
1222
1223     return 0
1224
1225 }
1226
1227 build_kernel_ib() {
1228     local linux="$1"
1229     local kib_prefix="$2"
1230     local kib_rpm="$3"
1231     local ofed_type="${4}"
1232     local ofed_version="${5}"
1233
1234     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1235     local K_SRC="K_SRC"
1236
1237         local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod \
1238         --with-user_access-mod --with-addr_trans-mod --with-madeye-mod"
1239         local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod \
1240         --with-mlx4_en-mod --with-cxgb3-mod --with-mlx4_en-mod \
1241         --with-cxgb3-mod --with-nes-mod --with-mlx5-mod --with-cxgb4-mod \
1242         --with-qib-mod"
1243
1244         # Removing the check for older version support
1245         #if compare_version $OFED_VERSION 3.0; then
1246         #OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1247         #else
1248         #OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1249         #fi
1250
1251     # some I/B drivers are architecture dependent and kernel-ib's configure
1252     # does not figure it out for us ~sigh~
1253     case "$TARGET_ARCH" in
1254         ppc64)
1255             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1256             ;;
1257     esac
1258     # we're no longer shipping the OFED iSCSI target
1259     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1260     OFED_ISCSI="--with-srp-mod"
1261     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1262     ##kernels >= 2.6.30)
1263     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1264     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1265     #fi
1266
1267     # assume we are just rebuilding the SRPM
1268     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1269     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1270
1271     # but switch to building from the SPEC if we need to apply patches
1272     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1273         BUILD_TYPE="-bb"
1274         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1275         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1276         local file ed_fragment1 ed_fragment2 n=1
1277         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1278             ed_fragment1="$ed_fragment1
1279 Patch$n: ${file%%*/}"
1280             ed_fragment2="$ed_fragment2
1281 %patch$n -p0"
1282             cp $file ${TOPDIR}/SOURCES
1283             let n=$n+1
1284         done
1285         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1286             # Only apply the ed-scripts that should be used for the canonical target
1287             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1288             # convention
1289             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1290             # To apply the same change to multiple canonical target simply specify
1291             # a list of colon separated canoncial target names in the file name.
1292             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1293                                    -e ":${CANONICAL_TARGET}.ed$"
1294             if [ $? -eq 0 ] ; then
1295                 ed_fragment3="$ed_fragment3
1296 $(cat $file)"
1297                 let n=$n+1
1298             fi
1299         done
1300
1301         if [ $n -gt 1 ]; then
1302             ed $SOURCE <<EOF
1303 /^Source: /a
1304 $ed_fragment1
1305 .
1306 /^%setup /a
1307 $ed_fragment2
1308 .
1309 $ed_fragment3
1310 wq
1311 EOF
1312         fi
1313     fi
1314
1315     local linuxrelease=$(find_linux_release)
1316         # a place to change/add any unique config
1317         case $ofed_type in
1318                 ofa|ifs) local K_SRC_OBJ="K_SRC_OBJ"
1319                 if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' \
1320                         --define 'build_kernel_ib_devel 1' \
1321                         ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1322                         --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1323                         --define "KVERSION ${linuxrelease}" \
1324                         --define "$K_SRC ${linux}" \
1325                         ${K_SRC_OBJ:+--define "$K_SRC_OBJ ${linux}"} \
1326                         ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1327                         --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1328                         ${SOURCE} 2>&1; then
1329                         fatal 1 "Error building ${kib_rpm}"
1330                 fi
1331                 ;;
1332                 mlnx)
1333                 if ! $RPMBUILD $BUILD_TYPE \
1334                         ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1335                         --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1336                         --define "KVERSION ${linuxrelease}" \
1337                         --define "$K_SRC ${linux}" \
1338                         ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1339                         --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1340                         ${SOURCE} 2>&1; then
1341                         fatal 1 "Error building ${kib_rpm}"
1342                 fi
1343                 # now that we have the kernel rpms, we need to lib rpms too
1344                 # we don't have to rebuild since MOFED include the binaries
1345                 cp -f OFED_RPMS/{libibmad-*,libibverbs-*,libibumad-*,librdmacm*,ibutils-*,opensm-libs*}.${TARGET_ARCH}.rpm \
1346                         ${TOPDIR}/RPMS/${TARGET_ARCH} || \
1347                         fatal 1 "Failed to copy MOFED rpms"
1348                 ;;
1349         esac
1350
1351 }
1352
1353 store_for_reuse() {
1354     local articles="$1"
1355     local module="$2"
1356     local location="$3"
1357     local signature="$4"
1358     local use_links="$5"
1359
1360     local linkflag=""
1361     if $use_links; then
1362         linkflag="l"
1363     fi
1364
1365     local unique_id=$(hostname -s)
1366     if [ -z "$unique_id" ]; then
1367         fatal 1 "Failed to determine hostname."
1368     fi
1369
1370     local finallocation="$location"/"$signature"/"$module"
1371     location="$location"/"$signature-${unique_id}"/"$module"
1372     mkdir -p "$location"
1373     # the cleanup script removes any directory that doesn't have a
1374     # .lastused, so let's try to prevent that as soon as we can
1375     # this solution still slightly racy with the cleanup script
1376     # but the race is a lot tighter now
1377     touch -t 197001010000 "$location/.lastused"
1378     ## use eval/echo here to make sure shell expansions are performed
1379     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1380     local article
1381     for article in $(eval echo $articles); do
1382         if ! cp -a${linkflag} "$article" "$location"; then
1383             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1384             # rename the cache location so that it's not cached
1385             # product, but is around for analysis
1386             mv "$location"{,-bad-$(date +%s)} ||
1387                 error "failed to clean up a failed cache attempt" \
1388                       "in \"$location\" -- manual cleanup will be" \
1389                       "necessary"
1390             return 1
1391         fi
1392     done
1393
1394     # flag the cache as complete (i.e. in case lbuild was previously
1395     # interrupted while caching)
1396     touch "$location/.lastused"
1397
1398     # put the temporary location into the final location
1399     # (last one wins)
1400     mkdir -p "${finallocation%/*}"
1401     mv "$location" "$finallocation"
1402     rmdir "${location%/*}"
1403     return 0
1404
1405 }
1406
1407 reuse() {
1408     local module="$1"
1409     local dest="$2"
1410     local use_links="${3:-false}"
1411     local signature="$4"
1412
1413     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1414         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1415             # the .lastused flag is populated at the end of the caching to
1416             # signal that the caching was completed.  if that flag is not
1417             # there, then the cache is invalid (and should be removed in fact)
1418             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1419                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1420             return 1
1421         fi
1422
1423         # so that we know how stale this entry is
1424         touch $REUSEBUILD/$signature/$module/.lastused
1425
1426         if $use_links; then
1427             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1428                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1429             fi
1430         else
1431             # copying is pretty heavy
1432             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1433             # do some creative symlinking instead
1434             local dir
1435             for dir in BUILD SRPMS SPECS; do
1436                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1437                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1438                 fi
1439             done
1440             # sources have to be copied by file because we need SOURCES to
1441             # be a dir we can write into
1442 # could overrun ls's arg list here
1443             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1444             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1445                 xargs ln -t $dest/SOURCES -s
1446
1447             # same for RPMS/* dirs
1448 # could overrun ls's arg list here
1449             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1450             local dir
1451             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1452                 mkdir -p $dest/RPMS/${dir##*/}
1453                 find $dir -type f |
1454                   xargs ln -t $dest/RPMS/${dir##*/} -s
1455             done
1456         fi
1457         return 0
1458     else
1459         return 1
1460     fi
1461 }
1462
1463 basearch() {
1464     local arch="$1"
1465
1466     if [[ $arch = i[3456]86 ]]; then
1467         echo "i386"
1468     else
1469         echo "$arch"
1470     fi
1471
1472 }
1473
1474 build_kernel_with_srpm() {
1475     local outfd=$1
1476
1477     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1478         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1479     fi
1480
1481     # need to generate the patch for this target
1482     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1483
1484     # get an md5sum of the kernel patch + config for reuse check
1485     local release_str
1486     if $RELEASE; then
1487         local release_str="RELEASE=$RELEASE\n"
1488     fi
1489
1490     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1491         local REUSE_SIGNATURE=$({ echo -en $release_str;
1492                                   echo $BUILD_GEN;
1493                                   cat "$CONFIG_FILE";
1494                                   cat "$TARGET_FILE" |
1495                                   sed -e '/_VERSION=/s/_[0-9]*_g.*$//g';
1496                                   cat "$FULL_PATCH";
1497                                   cat "$LBUILD_DIR/lbuild";
1498                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1499                                 md5sum | cut -d" " -f1)
1500         # see if we can link to the reuse pool
1501         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1502         #       "library"
1503         local CAN_LINK_FOR_REUSE=false
1504         touch $REUSEBUILD/$$
1505         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1506             CAN_LINK_FOR_REUSE=true
1507         fi
1508         rm $REUSEBUILD/$$
1509     fi
1510
1511     # the extra version string to use for the kernel (which might be a reused
1512     # kernel, remember)
1513     local kernel_extra_version=""
1514     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1515                                    "$REUSE_SIGNATURE"; then
1516         # nothing cached, build from scratch
1517         echo "Downloading kernel SRPM" >&${outfd}
1518         download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1519
1520         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1521                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1522             # should we clean this up or leave it for analysis?
1523             #rm -rf $RPMTOPDIR
1524             fatal 1 "Error installing kernel SRPM."
1525         fi
1526
1527         # put the Lustre kernel patch into the RPM build tree
1528         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1529         prepare_and_build_srpm >&${outfd} ||
1530             fatal 1 "failed to prepare_and_build_srpm"
1531
1532         if [ -z "$REUSE_SIGNATURE" ]; then
1533             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1534         else
1535             # store the resulting kernel RPM build tree for future use
1536             echo "Storing the built kernel for future reuse" >&${outfd}
1537             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1538                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1539                                  "$CAN_LINK_FOR_REUSE"; then
1540                 error "Failed to store kernel RPMS for reuse"
1541                 echo "unknown" >&${outfd}
1542                 return 1
1543             fi
1544         fi
1545     fi  # build reuse
1546
1547     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1548     local KERNEL_RPM
1549     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1550         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1551     fi
1552     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1553
1554     # should now have the following RPMs
1555     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1556     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1557     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1558     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1559     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1560
1561     echo $kernel_extra_version
1562     return 0
1563
1564 }
1565
1566 # build OFED
1567 # globals used:
1568 #    TOPDIR
1569 #    REUSEBUILD, USE_BUILD_CACHE
1570 #    CONFIGURE_FLAGS
1571
1572 build_ofed() {
1573         local linux="$1"
1574         local ofed_type="$2"
1575         local ofed_version="$3"
1576         local kib_prefix
1577         local kib_rpm
1578         local pre_prefix
1579         local o2ib_location
1580         local rpm
1581
1582     if [ "$ofed_version" = "inkernel" ]; then
1583         # see if there is a distro specific override for this and use
1584         # that if it exists
1585         # XXX we need to better integrate a distro specific override with
1586         #     the rest of this function so that all of the reuse cache
1587         #     stuff is leveraged given that 80% of this function is reuse
1588         if type -p build_ofed-$DISTROMAJ; then
1589             local ofed_location
1590             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1591             local rc=${PIPESTATUS[0]}
1592             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1593             return $rc
1594         else
1595             return 0
1596         fi
1597         else
1598                 case $ofed_type in
1599                         mlnx) # no compat-rdma for mlnx as of 3.1
1600                                 kib_prefix="ofa_kernel"
1601                                 pre_prefix="mlnx-"
1602                                 kib_rpm="${pre_prefix}${kib_prefix}"
1603                                 ;;
1604                         ofa|ifs)
1605                                 if compare_version $ofed_version 3.0; then
1606                                         kib_prefix="ofa_kernel"
1607                                         kib_rpm="${pre_prefix}${kib_prefix}"
1608                                 else
1609                                         kib_prefix="compat-rdma"
1610                                         kib_rpm="compat-rdma"
1611                                 fi
1612                                 ;;
1613                 esac
1614         fi
1615
1616     # build kernel-ib/compat-rdma
1617     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1618         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1619                                   echo "$(find_linux_release;
1620                                   echo "$BUILD_GEN")";
1621                                   cat "${linux}/include/linux/autoconf.h";
1622                                   cat "$LBUILD_DIR/lbuild";
1623                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1624                                 md5sum | cut -d" " -f1)
1625         # see if we can link to the reuse pool
1626         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1627         #       "library"
1628         local CAN_LINK_FOR_REUSE=false
1629         touch $REUSEBUILD/$$
1630         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1631             CAN_LINK_FOR_REUSE=true
1632         fi
1633         rm $REUSEBUILD/$$
1634     fi
1635
1636     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1637                                    "$REUSE_SIGNATURE"; then
1638         if [ -n "$REUSE_SIGNATURE" ]; then
1639             # stash away the existing built articles for a moment
1640             mkdir bak
1641             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1642             function mv_back {
1643                 pushd bak
1644                 find . | cpio -pudlm ..
1645                 popd
1646                 rm -rf bak
1647             }
1648             create_rpmbuild_dirs
1649         fi
1650         # build it
1651         build_kernel_ib "${linux}" "${pre_prefix}${kib_prefix}" "${kib_rpm}" "${ofed_type}"
1652
1653         if [ -z "$REUSE_SIGNATURE" ]; then
1654             echo "No reuse signature was caculated so not storing the built ofed"
1655         else
1656             # store the resulting RPM build tree for future use
1657             echo "Storing the built ofed for future reuse"
1658             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1659                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1660                                  "$CAN_LINK_FOR_REUSE"; then
1661                 error "Failed to store OFED RPMS for reuse"
1662                 mv_back
1663                 return 1
1664             fi
1665             # put the stuff we stashed away back
1666             mv_back
1667         fi
1668     fi
1669
1670     pushd "$TOPDIR" >/dev/null
1671     rm -rf ${kib_rpm}-devel
1672     mkdir ${kib_rpm}-devel
1673     cd ${kib_rpm}-devel
1674
1675         o2ib_location="$(pwd)/usr/src/${kib_prefix}"
1676         case $ofed_type in
1677                 mlnx) # Prior to MOFED 3.1, we had to use build_kernel_ib=1 to
1678                       # build devel rpm. not so after 3.1
1679                         if compare_version $ofed_version 3.0; then
1680                                 rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${ofed_version%%-*}-*.rpm)
1681                         else
1682                                 rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version%%-*}-*.rpm)
1683                         fi
1684                         o2ib_location="${o2ib_location}/default"
1685                         ;;
1686                 ofa) # Prior to OFA 3.18, we had to use build_kernel_ib=1 during configure,
1687                      # not so after 3.18
1688                         if compare_version $ofed_version 3.18; then
1689                                 rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${ofed_version%%-*}-*.rpm)
1690                         else
1691                                 rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version%%-*}-*.rpm)
1692                         fi
1693                         ;;
1694                 ifs) # ifs doesn't follow any convention (if any)
1695                         rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1696                         ;;
1697         esac
1698
1699         if ! rpm2cpio < $rpm | cpio -id; then
1700                 fatal 1 "could not unpack the $rpm."
1701         fi
1702         CONFIGURE_FLAGS="--with-o2ib=${o2ib_location} ${CONFIGURE_FLAGS}"
1703         popd >/dev/null
1704
1705 }
1706
1707 build_with_srpm() {
1708         local ofed_type="$1"
1709         local ofed_version="$2"
1710         local kernelrpm
1711
1712         if ! $PATCHLESS; then
1713                 if $PATCHLESS_SERVER; then
1714                         # need to find and unpack the vendor's own kernel-devel
1715                         # for patchless server build
1716                         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1717                                 fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1718                         fi
1719                         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1720                                 fatal 1 "Could not find the Linux tree in $kernelrpm"
1721                         fi
1722                         # download and unpack kernel-debuginfo-common (only in EL)
1723                         if [[ $DISTROMAJ =~ rhel ]]; then
1724                                 local KERNEL_DEBUGINFO="kernel-debuginfo-common-${TARGET_ARCH}-${lnxmaj}-${lnxrel}.${TARGET_ARCH}.rpm"
1725                                 download_debuginfo_common "$KERNEL_DEBUGINFO"
1726                                 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm \
1727                                         "$KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$KERNEL_DEBUGINFO"; then
1728                                         fatal 1 "Could not find the Linux debuginfo common rpm in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ/$TARGET_ARCH/$KERNEL_DEBUGINFO"
1729                                 fi
1730                         fi
1731                 else
1732                         local kernel_extra_version
1733                         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1734                                 fatal 1 "Failed to build the kernel from it's SRPM"
1735                         fi
1736
1737                         local kernel_devel_rpm
1738                         if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/${TARGET_ARCH}/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1739                                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/${TARGET_ARCH}/"
1740                         fi
1741
1742                         # install the -devel RPM in preparation for modules builds
1743                         if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1744                                 "$TOPDIR/RPMS/${TARGET_ARCH}/$kernel_devel_rpm"; then
1745                                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/${TARGET_ARCH}/$kernel_devel_rpm"
1746                         fi
1747                 fi
1748         else
1749                 # need to find and unpack the vendor's own kernel-devel for patchless
1750                 # client build
1751                 if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1752                         fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1753                 fi
1754                 if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1755                         fatal 1 "Could not find the Linux tree in $kernelrpm"
1756                 fi
1757         fi
1758
1759     # ~sigh~  have to make copies of and modify some of the rpm
1760     # infrastructure files so that find-requires can find our unpacked
1761     # kernel-devel artifacts
1762     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1763     export FIND_REQUIRES="$(pwd)/find-requires"
1764     chmod 755 {symset-table,find-requires{,.ksyms}}
1765     local tmp="$(pwd)"
1766     tmp="${tmp//\//\\/}"
1767     ed find-requires <<EOF
1768 1a
1769 set -x
1770 .
1771 /|.*find-requires.ksyms/s/|/| bash -x/
1772 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1773 wq
1774 EOF
1775     ed find-requires.ksyms <<EOF
1776 1a
1777 set -x
1778 .
1779 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1780 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1781 wq
1782 EOF
1783     ed symset-table <<EOF
1784 1a
1785 set -x
1786 .
1787 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1788 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1789 wq
1790 EOF
1791
1792         build_ofed "${LINUXOBJ:-$LINUX}" "$ofed_type" "$ofed_version" ||
1793         fatal 1 "error building OFED"
1794
1795     # now build Lustre
1796     if build_lustre "$LINUX" "$LINUXOBJ"; then
1797         # the build worked.  resolve any symlinked files (i.e. from reuse)
1798         # in RPMS/$arch to real files so that that that huge mess of
1799         # complication known as LTS can copy them yet somewhere else.
1800         # is it any wonder this whole process is so damn so?  anyone ever
1801         # heard of hardlinks?  it's this cool new thing that allows you save
1802         # tons of time and space by creating... well you can go read about
1803         # them if you have not heard about them yet.
1804         # can i say how much the implemenation of all of this really impedes
1805         # RPM reuse?
1806         local dir
1807         for dir in RPMS/*; do
1808             pushd $dir
1809             for file in $(ls); do
1810                 if [ -h $file ]; then
1811                     cp $file foo
1812                     mv foo $file
1813                 fi
1814             done
1815             popd
1816         done
1817         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1818         # as that's where LTS expects to find them
1819         for dir in RPMS/*; do
1820             if [ $dir = RPMS/$TARGET_ARCH ]; then
1821                 continue
1822             fi
1823             pushd $dir
1824             local files=$(ls)
1825             if [ -n "$files" ]; then
1826                 cp -al $files ../$TARGET_ARCH
1827             fi
1828             popd
1829         done
1830     else
1831         return 1
1832     fi
1833
1834 }
1835
1836 create_rpmbuild_dirs() {
1837
1838         [ -d RPMS ] || mkdir RPMS
1839         [ -d RPMS/${TARGET_ARCH} ] || mkdir RPMS/${TARGET_ARCH}
1840         [ -d RPMS/noarch ] || mkdir RPMS/noarch
1841         [ -d BUILD ] || mkdir BUILD
1842         [ -d SOURCES ] || mkdir SOURCES
1843         [ -d SPECS ] || mkdir SPECS
1844         [ -d SRPMS ] || mkdir SRPMS
1845
1846 }
1847
1848 new_list() {
1849
1850     echo ""
1851
1852 }
1853
1854 add_list() {
1855     local list="$1"
1856     local item="$2"
1857
1858     echo "$list $item"
1859
1860 }
1861
1862 is_list_member() {
1863     local list="$1"
1864     local item="$2"
1865
1866     [[ $list\  == *\ $item\ * ]]
1867
1868 }
1869
1870 #########################################################################
1871 # Generate a backtrace through the call stack.
1872 #
1873 # Input: None
1874 # Output: None
1875 #########################################################################
1876 backtrace() {
1877     local strip=${1:-1}
1878
1879     local funcname="" sourcefile="" lineno="" n
1880
1881     echo "Call stack: (most recent first)"
1882     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1883         funcname=${FUNCNAME[$n - 1]}
1884         sourcefile=$(basename ${BASH_SOURCE[$n]})
1885         lineno=${BASH_LINENO[$n - 1]}
1886         if [ $n = 1 ]; then
1887             let lineno-=11
1888         fi
1889         # Display function arguments
1890         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1891             local args newarg j p=0
1892             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1893                 newarg=${BASH_ARGV[$j + $p - 1]}
1894                 args="${args:+${args} }'${newarg}'"
1895             done
1896             let p+=${BASH_ARGC[$n - 1]}
1897         fi
1898         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1899     done
1900
1901     echo
1902     echo "BEGIN BACKTRACE"
1903
1904     #echo ${BASH_LINENO[*]}
1905     #echo ${BASH_SOURCE[*]}
1906     #echo ${FUNCNAME[*]}
1907     local i=$((${#FUNCNAME[@]} - 1))
1908     while [ $i -ge 0 ]; do
1909         local lineno=${BASH_LINENO[$i]}
1910         if [ $i = 0 ]; then
1911             let lineno-=11
1912         fi
1913         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1914         # Can't figure out how to get function args from other frames...
1915         local FUNCTION="${FUNCNAME[$i]}()"
1916         echo "$SOURCELINE:$FUNCTION"
1917         i=$((i - 1))
1918     done
1919
1920     echo "END BACKTRACE"
1921
1922     echo $BACKTRACE
1923
1924 }
1925
1926 seen_list=$(new_list)
1927 trap 'set +x;
1928 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1929 Unfortunately the above line number in the message may or may not be correct,
1930 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1931 echo
1932 # have we seen this one
1933 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1934
1935 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1936   echo "seen this one already"
1937 else
1938   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1939 fi
1940 backtrace
1941 ) ; set $xtrace' ERR
1942 set -E
1943
1944 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1945
1946 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,\
1947 patchless,patchless-server,ccache,norpm,external-patches:,timestamp:,\
1948 extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-type:,\
1949 ofed-version:,mlnx-version:,ofed-src:,publish,disable-zfs,release,set-value:,\
1950 src,stage:,target:,with-linux:,xen -- "$@")
1951
1952 if [ $? != 0 ]; then
1953     usage 1
1954 fi
1955
1956 eval set -- "$options"
1957
1958 while [ "$1" ]; do
1959     case "$1" in
1960         '')
1961             usage 1
1962             ;;
1963         --ccache)
1964             CCACHE='ccache'
1965             shift
1966             ;;
1967         -D)
1968             DATE=$2
1969             shift 2
1970             ;;
1971         --external-patches)
1972             EXTERNAL_PATCHES=$2
1973             shift 2
1974             ;;
1975         --extraversion)
1976             EXTRA_VERSION=$2
1977             shift 2
1978             ;;
1979         --help | -h)
1980             usage 0
1981             ;;
1982         --kerneldir)
1983             KERNELDIR=$2
1984             shift 2
1985             ;;
1986         --kerneltree)
1987             if ! KERNELTREE=$(canon_path "$2"); then
1988                 fatal 1 "Could not determine the canonical location of $2"
1989             fi
1990             shift 2
1991             ;;
1992         --linux | --with-linux)
1993             if ! LINUX=$(canon_path "$2"); then
1994                 fatal 1 "Could not determine the canonical location of $2"
1995             fi
1996             shift 2
1997             ;;
1998         --distro)
1999             DISTRO=$2
2000             shift 2
2001             ;;
2002         --reusebuild)
2003             if ! REUSEBUILD=$(canon_path "$2"); then
2004                 fatal 1 "Could not determine the canonical location of $2"
2005             fi
2006             shift 2
2007             ;;
2008         --norpm)
2009             shift
2010             ;;
2011         --noiokit)
2012             IOKITRPM=false
2013             shift
2014             ;;
2015         --patchless)
2016             PATCHLESS=true
2017             shift
2018             ;;
2019         --patchless-server)
2020                 PATCHLESS_SERVER=true
2021                 shift
2022                 ;;
2023         --kernelrpm)
2024             if ! KERNELRPMSBASE=$(canon_path "$2"); then
2025                 fatal 1 "Could not determine the canonical location of $2"
2026             fi
2027             shift 2
2028             ;;
2029         --timestamp)
2030             TIMESTAMP=$2
2031             shift 2
2032             ;;
2033         --lustre)
2034             if ! LUSTRE=$(canon_filepath "$2"); then
2035                 fatal 1 "Could not determine the canonical location of $2"
2036             fi
2037             shift 2
2038             ;;
2039         --nodownload)
2040             DOWNLOAD=false
2041             shift 1
2042             ;;
2043         --nosrc)
2044             DO_SRC=false
2045             shift 1
2046             ;;
2047         --ofed-version)
2048             OFED_VERSION="$2"
2049             shift 2
2050             ;;
2051         --ofed-type)
2052                 OFED_TYPE="$2"
2053                 shift 2
2054                 ;;
2055         --ofed-src)
2056                 OFED_SRC="$2"
2057                 shift 2
2058                 ;;
2059         --publish)
2060             shift
2061             ;;
2062         --disable-zfs)
2063             WITH_ZFS="no"
2064             shift
2065             ;;
2066         --release)
2067             RELEASE=true
2068             shift
2069             ;;
2070         --src)
2071             DO_SRC=true
2072             shift 1
2073             ;;
2074         --stage)
2075             STAGEDIR=$2
2076             shift 2
2077             ;;
2078         --target)
2079             TARGET=$2
2080             shift 2
2081             ;;
2082         --xen)
2083             XEN=true
2084             shift
2085             ;;
2086         --set-value)
2087             eval $2
2088             shift 2
2089             ;;
2090         --)
2091             shift
2092             # there are actually some lustre configure flags that we need to
2093             # handle ourselves (but we still give them to configure)
2094             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
2095                 LUSTRE_TESTS=false
2096             fi
2097             CONFIGURE_FLAGS=$@
2098             break
2099             ;;
2100         *)
2101             usage 1 "Unrecognized option: $1"
2102             ;;
2103     esac
2104 done
2105
2106 check_options
2107
2108 unpack_lustre
2109
2110 load_target
2111
2112         if [ -n "$OFED_TYPE" -a "$OFED_TYPE" != "inkernel" ]; then
2113                 download_ofed "$OFED_TYPE" "$OFED_VERSION"
2114                 unpack_ofed "$OFED_TYPE" "$OFED_VERSION" || fatal 1 "Error unpacking OFED tarball"
2115         fi
2116
2117 # make sure the RPM build environment is set up
2118 create_rpmbuild_dirs
2119
2120 # if an unpacked kernel source tree was given on the command line
2121 # just build lustre with it (nothing distro kernel specific here)
2122 if [ -n "$LINUX" ]; then
2123     find_linux_release() {
2124         _find_linux_release $LINUX
2125     }
2126         build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_TYPE" "$OFED_VERSION" ||
2127         fatal 1 "error building OFED"
2128     build_lustre "$LINUX" "$LINUXOBJ"
2129 else
2130     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
2131         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
2132     fi
2133     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
2134         build_with_srpm "$OFED_TYPE" "$OFED_VERSION" || fatal 1 "Failed to build_with_srpm"
2135 fi
2136
2137 stage